
#include "DecodeIR.h"
#include <string.h>

typeDecodeIR lpfnDecodeIR;
typeProtocolSupportLevel lpfnProtocolSupportLevel;

HINSTANCE LoadDll() 
{
	HINSTANCE hDll = NULL;
	hDll = LoadLibrary("DecodeIR.dll");
	if (hDll != NULL)
	{
		lpfnDecodeIR = (typeDecodeIR)GetProcAddress(hDll,
			"DecodeIR");
		if (lpfnDecodeIR==0) {
			FreeLibrary(hDll);
			hDll = NULL;
		};

		lpfnProtocolSupportLevel = (typeProtocolSupportLevel)GetProcAddress(hDll,
			"ProtocolSupportLevel");
		if (lpfnProtocolSupportLevel==0) {
			FreeLibrary(hDll);
			hDll = NULL;
		};
	};
	return hDll;
}

/*int ProtocolSupportLevel(char *Protocol) {
	if (hDll != NULL)
		return lpfnProtocolSupportLevel(Protocol);
	else
		return 0;
}*/

int HexCmdToEFC(int iHexCmd) {

	int Result;
	Result = ( ( ((iHexCmd << 3)+(iHexCmd >> 5)) ^ 0xAE ) + 100 ) & 0xFF;
	return Result;
}

int TryDLL(pairArray &Data,int iCarrier, int iOneTimeLength,int iRepeatLength)
{
	char szProtocol[255] = "";
	unsigned int iaContext[2] = {0,0};
	int iDevice =0;
	int iSubDevice=0;
	int iOBC=0;
	int lpiHex[4] = {-1,-1,-1,-1};
	char szMisc[255]= "";
	char szError[255]= "";
	int *ip = new int[2*(iOneTimeLength + iRepeatLength)];
	int i;
	int result;
	int iCarrierHz;
	char szMessage[2024] = "";

	result = 0;

	iCarrierHz = int((1000.0 / (float(iCarrier) * 0.241246)) * 1000);

	//Convert the float bursts to intetger bursts
	for (i=0;i<(iOneTimeLength + iRepeatLength);i++)
	{
		ip[2*i] = int(Data[i].pair[0] * iCarrier * 0.241246);
		ip[2*i+1] = int(Data[i].pair[1] * iCarrier * 0.241246);
	};

	//Call the DecodeIR function
	lpfnDecodeIR(iaContext, ip,iCarrierHz,iOneTimeLength,iRepeatLength,szProtocol,&iDevice,&iSubDevice,&iOBC,lpiHex,szMisc,szError);

	while (szProtocol[0] != 0) {
		//Print the result
		if (iSubDevice == 0)
			sprintf(szMessage,"%sProtocol:\t%s\nDevice:\t%d\nOBC:\t%d\nEFC:\t%d\n\n",szMessage,szProtocol,iDevice, iOBC,HexCmdToEFC(lpiHex[0]));
		else
			sprintf(szMessage,"%sProtocol:\t%s\nDevice:\t%d.%d\nOBC:\t%d\nEFC:\t%d\n\n",szMessage,szProtocol,iDevice,iSubDevice, iOBC,HexCmdToEFC(lpiHex[0]));

		//Try another decode
		lpfnDecodeIR(iaContext, ip,iCarrierHz,iOneTimeLength,iRepeatLength,szProtocol,&iDevice,&iSubDevice,&iOBC,lpiHex,szMisc,szError);
	};

	if (szMessage[0] != 0) 
		MessageBox(0,szMessage,"DecodeIR DLL Results",MB_OK);

	delete [] ip;

	return result;
}
